%{

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream>

using namespace std;

  /* compiled with flex with the -i flag so that case of the code being */
  /*    scaned is ignored. makes for easier more efficient scanning .   */

  int line_num = 1;

  char tokenString[80];

  int init_p = 1;

  const bool flag = 0;


  /* Function prints the start-point, end-point and the type of a token */
  void print_lisp( int& start, int leng, char* type, char* text )
  {
    if (flag)
      cout << start << " " << start + leng << " " << type 
	   << "\t ---------------> " << text << endl;
    else
      cout << "( " << start << " " << start + leng << " " << type << " ) ";
    start += leng;
  }

%}



esc  _
alpha			[A-Za-z%]
one_digit		[2-9]
digit			[0-9]
esc_digit		{digit}|{esc}
long_digit		{digit}|[A-Z]
esc_long_digit		{long_digit}|{esc}
radix		{digit}{esc_digit}*"r"
int  {one_digit}|{digit}{esc_digit}+|{radix}{esc_long_digit}+
expon    [eE][+-]?{esc_digit}+
float    {digit}*"."{esc_digit}+{expon}?|{digit}+"."{esc_digit}*{expon}?|{digit}+{expon}|{radix}{esc_long_digit}*"."{esc_long_digit}+{expon}?|{radix}{esc_long_digit}+"."{esc_long_digit}*{expon}?|{radix}{esc_long_digit}+{expon}
dot  "."
id  "0"|"1"|{alpha}({alpha}|{digit}|[!?|])*
quote  [""]
string_char  [^_""\n]|esc[^\n]
ws  \t|" "
nl  \n["\015"]
 /*reserved_op = [\[(),:;\]{}$\'|] | "=>" | "==>" | "+->" | ":=" | "==" ;
  */
future_word  "delay"|"fix"|"is"|"isnt"|"let"|"rule"
future_op    [\[{(]"|"|"|"[\]})]|[`&]|"||"
definable_op_word  "by"|"case"|"mod"|"quo"|"rem"
definable_op  [\-\\#*+/<=>@~\^]|"<<"|">>"|"<="|">="|"<-"|"->"|"\\/"|"/\\"|"**"|".."|"~="|"^="
pre_doc   "+++".*
post_doc  "++".*
comment   "--".*
string  \"[^\"]*\"

%%

{ws}             ++init_p;
{nl}             ++init_p;
"\015"           ++init_p;


add         { print_lisp( init_p, yyleng, "aldor-reserved", "ADD" );}
always      { print_lisp( init_p, yyleng, "aldor-reserved", "ALWAYS" );}
and         { print_lisp( init_p, yyleng, "aldor-reserved", "AND" );}
assert      { print_lisp( init_p, yyleng, "aldor-reserved", "ASSERT" );}
break       { print_lisp( init_p, yyleng, "aldor-reserved", "BREAK" );}
but         { print_lisp( init_p, yyleng, "aldor-reserved", "BUT" );}
catch       { print_lisp( init_p, yyleng, "aldor-reserved", "CATCH" );}
default     { print_lisp( init_p, yyleng, "aldor-reserved", "DEFAULT" );}
define      { print_lisp( init_p, yyleng, "aldor-reserved", "DEFINE" );}
delay       { print_lisp( init_p, yyleng, "aldor-reserved", "DELAY" );}
do          { print_lisp( init_p, yyleng, "aldor-reserved", "DO" );}
else        { print_lisp( init_p, yyleng, "aldor-reserved", "ELSE" );}
except      { print_lisp( init_p, yyleng, "aldor-reserved", "EXCEPT" );}
export      { print_lisp( init_p, yyleng, "aldor-reserved", "EXPORT" );}
extend      { print_lisp( init_p, yyleng, "aldor-reserved", "EXTEND" );}
fix         { print_lisp( init_p, yyleng, "aldor-reserved", "FIX" );}
fluid       { print_lisp( init_p, yyleng, "aldor-reserved", "FLUID" );}
for         { print_lisp( init_p, yyleng, "aldor-reserved", "FOR" );}
free        { print_lisp( init_p, yyleng, "aldor-reserved", "FREE" );}
from        { print_lisp( init_p, yyleng, "aldor-reserved", "FROM" );}
generate    { print_lisp( init_p, yyleng, "aldor-reserved", "GENERATE" );}
goto        { print_lisp( init_p, yyleng, "aldor-reserved", "GOTO" );}
has         { print_lisp( init_p, yyleng, "aldor-reserved", "HAS" );}
if          { print_lisp( init_p, yyleng, "aldor-reserved", "IF" );}
import      { print_lisp( init_p, yyleng, "aldor-reserved", "IMPORT" );}
in          { print_lisp( init_p, yyleng, "aldor-reserved", "IN" );}
inline      { print_lisp( init_p, yyleng, "aldor-reserved", "INLINE" );}
is          { print_lisp( init_p, yyleng, "aldor-reserved", "IS" );}
isnt        { print_lisp( init_p, yyleng, "aldor-reserved", "ISNT" );}
iterate     { print_lisp( init_p, yyleng, "aldor-reserved", "ITERATE" );}
let         { print_lisp( init_p, yyleng, "aldor-reserved", "LET" );}
local       { print_lisp( init_p, yyleng, "aldor-reserved", "LOCAL" );}
macro       { print_lisp( init_p, yyleng, "aldor-reserved", "MACRO" );}
never       { print_lisp( init_p, yyleng, "aldor-reserved", "NEVER" );}
not         { print_lisp( init_p, yyleng, "aldor-reserved", "NOT" );}
of          { print_lisp( init_p, yyleng, "aldor-reserved", "OF" );}
or          { print_lisp( init_p, yyleng, "aldor-reserved", "OR" );}
pretend     { print_lisp( init_p, yyleng, "aldor-reserved", "PRETEND" );}
ref         { print_lisp( init_p, yyleng, "aldor-reserved", "REF" );}
repeat      { print_lisp( init_p, yyleng, "aldor-reserved", "REPEAT" );}
return      { print_lisp( init_p, yyleng, "aldor-reserved", "RETURN" );}
rule        { print_lisp( init_p, yyleng, "aldor-reserved", "RULE" );}
select      { print_lisp( init_p, yyleng, "aldor-reserved", "SELECT" );}
then        { print_lisp( init_p, yyleng, "aldor-reserved", "THEN" );}
throw       { print_lisp( init_p, yyleng, "aldor-reserved", "THROW" );}
to          { print_lisp( init_p, yyleng, "aldor-reserved", "TO" );}
try         { print_lisp( init_p, yyleng, "aldor-reserved", "TRY" );}
where       { print_lisp( init_p, yyleng, "aldor-reserved", "WHERE" );}
while       { print_lisp( init_p, yyleng, "aldor-reserved", "WHILE" );}
with        { print_lisp( init_p, yyleng, "aldor-reserved", "WITH" );}
yield       { print_lisp( init_p, yyleng, "aldor-reserved", "YIELD" );}


  /* Definable op words */
"by"        { print_lisp( init_p, yyleng, "aldor-def-op-word", "BY" ); }
"case"      { print_lisp( init_p, yyleng, "aldor-def-op-word", "CASE" );}
"mod"       { print_lisp( init_p, yyleng, "aldor-def-op-word", "MOD" );}
"quo"       { print_lisp( init_p, yyleng, "aldor-def-op-word", "QUO" );}
"rem"       { print_lisp( init_p, yyleng, "aldor-def-op-word", "REM" );}


  /* when user include class,  the following MAY become keyword */

boolean|DoubleFloat|false|Integer|List|TextWriter|String|true|Character|MachineInteger {
    strncpy(tokenString,yytext,20);
    print_lisp( init_p, yyleng, "aldor-class", yytext );
  }

  /* import functions */

stdout|newline|space|include|rep|per|Per {
  strncpy(tokenString,yytext,20);
  print_lisp( init_p, yyleng, "aldor-import-function", yytext);
 }


  /* pre_doc */
{pre_doc} {
  strncpy(tokenString,yytext,20);
  print_lisp( init_p, yyleng, "aldor-pre-doc", yytext);
}


  /* post_doc */
{post_doc} {
   strncpy(tokenString,yytext,20);
   print_lisp( init_p, yyleng, "aldor-post-doc", yytext);
 }


  /* Comment */
{comment} {
   strncpy(tokenString,yytext,20);
   print_lisp( init_p, yyleng, "aldor-comment", yytext);
}

  /* String */
{string} {
  strncpy(tokenString,yytext,20);
  print_lisp( init_p, yyleng, "aldor-string", yytext);
}

{id} {
  strncpy(tokenString,yytext,20);
  print_lisp( init_p, yyleng, "aldor-id", yytext);  
}
{float} {
  strncpy(tokenString,yytext,20);
  print_lisp( init_p, yyleng, "aldor-float", yytext);
}
{int} {
  strncpy(tokenString,yytext,20);
  print_lisp( init_p, yyleng, "aldor-int", yytext);
}

  /* Definable ops */
"\\"    { print_lisp( init_p, yyleng, "aldor-def-opw", "SETMINUS" ); }
"#"     { print_lisp( init_p, yyleng, "aldor-def-op", "POUND" );}
"*"     { print_lisp( init_p, yyleng, "aldor-def-op", "TIMES" );}
"+"     { print_lisp( init_p, yyleng, "aldor-def-op", "PLUS" );}
"-"     { print_lisp( init_p, yyleng, "aldor-def-op", "MINUS" );}
"/"     { print_lisp( init_p, yyleng, "aldor-def-op", "DIVIDE" );}
"<"     { print_lisp( init_p, yyleng, "aldor-def-op", "LESSTHAN" );}
"="     { print_lisp( init_p, yyleng, "aldor-def-op", "EQUALS" );}
">"     { print_lisp( init_p, yyleng, "aldor-def-op", "GREATERTHAN" );}
"@"     { print_lisp( init_p, yyleng, "aldor-def-op", "ATSIGN" );}
"~"     { print_lisp( init_p, yyleng, "aldor-def-op", "TILDE" );}
"^"     { print_lisp( init_p, yyleng, "aldor-def-op", "CARET" );}
"<<"    { print_lisp( init_p, yyleng, "aldor-def-op", "VERY_LESS" );}
">>"    { print_lisp( init_p, yyleng, "aldor-def-op", "VERY_GREATER" );}
"<="    { print_lisp( init_p, yyleng, "aldor-def-op", "LESSEQ" );}
">="    { print_lisp( init_p, yyleng, "aldor-def-op", "GREATEREQ" );}
"<-"    { print_lisp( init_p, yyleng, "aldor-def-op", "GETS" );}
"->"    { print_lisp( init_p, yyleng, "aldor-def-op", "TO_SYMBOL" );}
"\\/"   { print_lisp( init_p, yyleng, "aldor-def-op", "JOIN" );}
"/\\"   { print_lisp( init_p, yyleng, "aldor-def-op", "MEET" );}
"**"    { print_lisp( init_p, yyleng, "aldor-def-op", "STARTSTAR" );}
".."    { print_lisp( init_p, yyleng, "aldor-def-op", "DOTDOT" );}
"~="    { print_lisp( init_p, yyleng, "aldor-def-op", "UNEQUALS" );}
"^="    { print_lisp( init_p, yyleng, "aldor-def-op", "CARETEQUALS" );}

  /* Reserved ops */
"$"     { print_lisp( init_p, yyleng, "aldor-res-op", "DALLAR" );}
"'"     { print_lisp( init_p, yyleng, "aldor-res-op", "SQUOTE" );}
"("     { print_lisp( init_p, yyleng, "aldor-res-op", "LPAREN" );}
")"     { print_lisp( init_p, yyleng, "aldor-res-op", "RPAREN" );}
"+->"   { print_lisp( init_p, yyleng, "aldor-res-op", "FUN_ARROW" );}
","     { print_lisp( init_p, yyleng, "aldor-res-op", "COMMA" );}
":"     { print_lisp( init_p, yyleng, "aldor-res-op", "COLON" );}
":="    { print_lisp( init_p, yyleng, "aldor-res-op", "IS_ASSIGNED" );}
";"     { print_lisp( init_p, yyleng, "aldor-res-op", "SEMI" );}
"==>"   { print_lisp( init_p, yyleng, "aldor-res-op", "MACRO_IS" );}
"=>"    { print_lisp( init_p, yyleng, "aldor-res-op", "EXIT" );}
"["     { print_lisp( init_p, yyleng, "aldor-res-op", "LBRACK" );}
"]"     { print_lisp( init_p, yyleng, "aldor-res-op", "RBRACK" );}
"{"     { print_lisp( init_p, yyleng, "aldor-res-op", "LBRACE" );}
"}"     { print_lisp( init_p, yyleng, "aldor-res-op", "RBRACE" );}
"=="    { print_lisp( init_p, yyleng, "aldor-res-op", "VERY_EQUAL" );}
"|"     { print_lisp( init_p, yyleng, "aldor-res-op", "BAR" );}

   /* Future ops */
"[|"    { print_lisp( init_p, yyleng, "aldor-future-op", "LLBRACK" );}
"{|"    { print_lisp( init_p, yyleng, "aldor-future-op", "LLBRACE" );}
"(|"    { print_lisp( init_p, yyleng, "aldor-future-op", "LLPAREN" );}
"|]"    { print_lisp( init_p, yyleng, "aldor-future-op", "RRBRACK" );}
"|}"    { print_lisp( init_p, yyleng, "aldor-future-op", "RRBRACE" );}
"|)"    { print_lisp( init_p, yyleng, "aldor-future-op", "RRPAREN" );}
"`"     { print_lisp( init_p, yyleng, "aldor-future-op", "GRAVE" );}
"&"     { print_lisp( init_p, yyleng, "aldor-future-op", "AMPERSAND" );}
"||"    { print_lisp( init_p, yyleng, "aldor-future-op", "OROR" );}


%%

#include<iostream>
#include<fstream>
#include <string>
using namespace std;

bool SCANNER = true;    // scanner is completed and is to be run

int main(int argc, char * argv[] )
{
    char* programfile; //the sourse file to compile in pascal

    // check to see if the user input 2 argument one the program and one the
    // file to compiled
    if(argc != 2)
    {
        // log if the format given is not corredt and exits
        cout  <<"two arguments are needed usage: "<< argv[0]
              <<" <filename.as>\n";
        exit(1);
    }

    // get the name of the file to be compiled
    programfile = argv[1];

    // opnes the source for use in the compiler then checks to see where the
    // file exist or not if does not log problem and exits
    yyin = fopen(programfile, "r");

    if(yyin == NULL)
    {
        cout<<"compile file not found\n";
        exit(1);
    }
    // prints to the user and the log that the compile process has started
    //cout << "( ";

    if(SCANNER)
      yylex();

    //cout << ")" << endl;
    return 0;
}

int yywrap()
{
    return 1;
}
